--make sure to add "UITableViewDataSource", "UITableViewDelegate" as protocols
waxClass{"viewWithTable", UIViewController, protocols = {"UITableViewDataSource", "UITableViewDelegate"}}

function init(self)
	self.super:init()
	return self
end

function viewDidLoad(self)
	--set items to show in table
	items = {"one", "two", "three"}
	
	--set view color to white
	self:view():setBackgroundColor(UIColor:whiteColor())

	--create the table
	self.tableView = UITableView:initWithFrame_style(CGRect(0,0,320,480),UITableViewStylePlain)
	--set its background color
	self.tableView:setBackgroundColor(UIColor:clearColor())
	--self.tableView:setBackgroundColor(UIColor:lightGrayColor())
	--set the data source to this view
	self.tableView:setDataSource(self)
	--set the delegate to this view
	self.tableView:setDelegate(self)
	--add it to the view
	self:view():addSubview(self.tableView)
end

function viewWillAppear(self)
	--self.tableView:reloadData()
end

------------------------------------- Table View Data Source -------------------------------------
function numberOfSectionsInTableView(self, tableView)
	--number of sections in the table
	return 1
end

function tableView_numberOfRowsInSection(self, tableView, section)
	-- if there's more than 0 items in array
	if (#items > 0) then
		--return number of items as number of rows needed
		return #items
	else
		-- otherwise return 4
		-- this is so I can display a message on row 3 not needed
		return 4
	end
end

function tableView_heightForRowAtIndexPath(self, tableView, indexPath)
	--set cell height
	return 60
end

function tableView_cellForRowAtIndexPath(self, tableView, indexPath)

	local identifier = "cell"
	local cell = tableView:dequeueReusableCellWithIdentifier(identifier)
	
	-- Make custom cell if not exist
	if (cell == nil) then
		cell = UITableViewCell:initWithStyle_reuseIdentifier(UITableViewCellStyleDefault, identifier)  
		
		-- Add label in center of cell to fill whole cell text size 25
		--create label
		itmName = UILabel:initWithFrame(CGRect(0,0,320,60))
		--set label background color
		itmName:setBackgroundColor(UIColor:clearColor())
		--set text alignment
		itmName:setTextAlignment(UITextAlignmentCenter)
		--set text color
		itmName:setTextColor(UIColor:colorWithRed_green_blue_alpha(120/255,120/255,120/255,1))
		--set text size
		itmName:setFont(UIFont:systemFontOfSize(25))
		--set its tag
		itmName:setTag(1)
		--add it to the cell
		cell:contentView():addSubview(itmName)
	else
		--Otherwise get current cells label
		itmName = cell:contentView():viewWithTag(1)
	end
	
	--if there's more than 0 items
	if (#items > 0) then
		--Get the item position in array
		local itmTo = indexPath:row()+1
		--Set the label text color
		itmName:setTextColor(UIColor:colorWithRed_green_blue_alpha(120/255,120/255,120/255,1))
		--Set the text on the label
		itmName:setText(items[itmTo])
	else
	--Otherwise
		if (indexPath:row() == 2) then
			itmName:setTextColor(UIColor:lightGrayColor())
			itmName:setText("Nothing To See Here")
		else
			itmName:setText("")
		end
	end
	
	--Return the cell for that position in the table
	return cell
end

------------------------------------- Table View Delegate -------------------------------------

function tableView_canEditRowAtIndexPath(self, tableView, indexPath)
	--Make cells editable
	return true
end

function tableView_editingStyleForRowAtIndexPath(self, tableView, indexPath)
	--When editiing show delete button
	return UITableViewCellEditingStyleDelete
end

function tableView_commitEditingStyle_forRowAtIndexPath(self, tableView, editingStyle, indexPath)
	--If deleting
	if (editingStyle == UITableViewCellEditingStyleDelete) then
		--Remove from the array
		table.remove(items,indexPath:row()+1)
		--Reload tableView
		tableView:reloadData()
	end
end

function tableView_didSelectRowAtIndexPath(self, tableView, indexPath)
	--If a row is selected, deselect it
	self.tableView:deselectRowAtIndexPath_animated(indexPath, true)
end